org.codehaus.groovy.runtime

## Class DefaultGroovyStaticMethods

- java.lang.Object
- - org.codehaus.groovy.runtime.DefaultGroovyStaticMethods

-     public class DefaultGroovyStaticMethods
      extends java.lang.Object

  This class defines all the new static groovy methods which appear on normal JDK classes inside the Groovy environment. Static methods are used with the first parameter as the destination class.
  Author:
    Guillaume Laforge, Dierk Koenig, Joachim Baumann, Paul King, Kent Inge Fagerland Simonsen

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `DefaultGroovyStaticMethods()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static java.io.File` | `createTempDir(java.io.File self)`
    `static java.io.File` | `createTempDir(java.io.File self, java.lang.String prefix, java.lang.String suffix)`
    `static long` | `currentTimeSeconds(java.lang.System self)` Get the current time in seconds
    `static java.util.ResourceBundle` | `getBundle(java.util.ResourceBundle self, java.lang.String bundleName)` Works exactly like ResourceBundle.getBundle(String).
    `static java.util.ResourceBundle` | `getBundle(java.util.ResourceBundle self, java.lang.String bundleName, java.util.Locale locale)` Works exactly like ResourceBundle.getBundle(String, Locale).
    `static java.util.regex.Matcher` | `getLastMatcher(java.util.regex.Matcher self)` Get the last hidden matcher that the system used to do a match.
    `static java.util.Date` | `parse(java.util.Date self, java.lang.String format, java.lang.String input)` Parse a String into a Date instance using the given pattern.
    `static java.util.Date` | `parse(java.util.Date self, java.lang.String format, java.lang.String input, java.util.TimeZone zone)` Parse a String into a Date instance using the given pattern and TimeZone.
    `static java.util.Date` | `parseToStringDate(java.util.Date self, java.lang.String dateToString)` Parse a String matching the pattern EEE MMM dd HH:mm:ss zzz yyyy containing US-locale-constants only (e.g.
    `static void` | `sleep(java.lang.Object self, long milliseconds)` Sleep for so many milliseconds, even if interrupted.
    `static void` | `sleep(java.lang.Object self, long milliseconds, Closure onInterrupt)` Sleep for so many milliseconds, using a given closure for interrupt processing.
    `static java.lang.Thread` | `start(java.lang.Thread self, Closure closure)` Start a Thread with the given closure as a Runnable instance.
    `static java.lang.Thread` | `start(java.lang.Thread self, java.lang.String name, Closure closure)` Start a Thread with a given name and the given closure as a Runnable instance.
    `static java.lang.Thread` | `startDaemon(java.lang.Thread self, Closure closure)` Start a daemon Thread with the given closure as a Runnable instance.
    `static java.lang.Thread` | `startDaemon(java.lang.Thread self, java.lang.String name, Closure closure)` Start a daemon Thread with a given name and the given closure as a Runnable instance.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DefaultGroovyStaticMethods

          public DefaultGroovyStaticMethods()

  - ### Method Detail

    - #### start

          public static java.lang.Thread start(java.lang.Thread self,
                                               Closure closure)

      Start a Thread with the given closure as a Runnable instance.
      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
        `closure` - the Runnable closure
      Returns:
        the started thread
      Since:
        1.0

    - #### start

          public static java.lang.Thread start(java.lang.Thread self,
                                               java.lang.String name,
                                               Closure closure)

      Start a Thread with a given name and the given closure as a Runnable instance.
      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
        `name` - the name to give the thread
        `closure` - the Runnable closure
      Returns:
        the started thread
      Since:
        1.6

    - #### startDaemon

          public static java.lang.Thread startDaemon(java.lang.Thread self,
                                                     Closure closure)

      Start a daemon Thread with the given closure as a Runnable instance.
      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
        `closure` - the Runnable closure
      Returns:
        the started thread
      Since:
        1.0

    - #### startDaemon

          public static java.lang.Thread startDaemon(java.lang.Thread self,
                                                     java.lang.String name,
                                                     Closure closure)

      Start a daemon Thread with a given name and the given closure as a Runnable instance.
      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
        `name` - the name to give the thread
        `closure` - the Runnable closure
      Returns:
        the started thread
      Since:
        1.6

    - #### getLastMatcher

          public static java.util.regex.Matcher getLastMatcher(java.util.regex.Matcher self)

      Get the last hidden matcher that the system used to do a match.
      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
      Returns:
        the last regex matcher
      Since:
        1.0

    - #### sleep

          public static void sleep(java.lang.Object self,
                                   long milliseconds)

      Sleep for so many milliseconds, even if interrupted.
      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
        `milliseconds` - the number of milliseconds to sleep
      Since:
        1.0

    - #### sleep

          public static void sleep(java.lang.Object self,
                                   long milliseconds,
                                   Closure onInterrupt)

      Sleep for so many milliseconds, using a given closure for interrupt processing.
      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
        `milliseconds` - the number of milliseconds to sleep
        `onInterrupt` - interrupt handler, InterruptedException is passed to the Closure as long as it returns false, the sleep continues
      Since:
        1.0

    - #### parse

          public static java.util.Date parse(java.util.Date self,
                                             java.lang.String format,
                                             java.lang.String input)
                                      throws java.text.ParseException

      Parse a String into a Date instance using the given pattern. This convenience method acts as a wrapper for `SimpleDateFormat`.

      Note that a new SimpleDateFormat instance is created for every invocation of this method (for thread safety).

      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
        `format` - pattern used to parse the input string.
        `input` - String to be parsed to create the date instance
      Returns:
        a new Date instance representing the parsed input string
      Throws:
        `java.text.ParseException` - if there is a parse error
      Since:
        1.5.7
      See Also:
        `DateFormat.parse(java.lang.String)`

    - #### parse

          public static java.util.Date parse(java.util.Date self,
                                             java.lang.String format,
                                             java.lang.String input,
                                             java.util.TimeZone zone)
                                      throws java.text.ParseException

      Parse a String into a Date instance using the given pattern and TimeZone. This convenience method acts as a wrapper for `SimpleDateFormat`.

      Note that a new SimpleDateFormat instance is created for every invocation of this method (for thread safety).

      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
        `format` - pattern used to parse the input string.
        `input` - String to be parsed to create the date instance
        `zone` - TimeZone to use when parsing
      Returns:
        a new Date instance representing the parsed input string
      Throws:
        `java.text.ParseException` - if there is a parse error
      Since:
        2.4.1
      See Also:
        `DateFormat.parse(java.lang.String)`

    - #### parseToStringDate

          public static java.util.Date parseToStringDate(java.util.Date self,
                                                         java.lang.String dateToString)
                                                  throws java.text.ParseException

      Parse a String matching the pattern EEE MMM dd HH:mm:ss zzz yyyy containing US-locale-constants only (e.g. Sat for Saturdays). Such a string is generated by the toString method of `Date`

      Note that a new SimpleDateFormat instance is created for every invocation of this method (for thread safety).

      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
        `dateToString` - String to be parsed to create the date instance. Must match the pattern EEE MMM dd HH:mm:ss zzz yyyy with US-locale symbols
      Returns:
        a new Date instance representing the parsed input string
      Throws:
        `java.text.ParseException` - if there is a parse error

    - #### getBundle

          public static java.util.ResourceBundle getBundle(java.util.ResourceBundle self,
                                                           java.lang.String bundleName)

      Works exactly like ResourceBundle.getBundle(String). This is needed because the java method depends on a particular stack configuration that is not guaranteed in Groovy when calling the Java method.
      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
        `bundleName` - the name of the bundle.
      Returns:
        the resource bundle
      Since:
        1.6.0
      See Also:
        `ResourceBundle.getBundle(java.lang.String)`

    - #### getBundle

          public static java.util.ResourceBundle getBundle(java.util.ResourceBundle self,
                                                           java.lang.String bundleName,
                                                           java.util.Locale locale)

      Works exactly like ResourceBundle.getBundle(String, Locale). This is needed because the java method depends on a particular stack configuration that is not guaranteed in Groovy when calling the Java method.
      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
        `bundleName` - the name of the bundle.
        `locale` - the specific locale
      Returns:
        the resource bundle
      Since:
        1.6.0
      See Also:
        `ResourceBundle.getBundle(java.lang.String, java.util.Locale)`

    - #### createTempDir

          public static java.io.File createTempDir(java.io.File self)
                                            throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### createTempDir

          public static java.io.File createTempDir(java.io.File self,
                                                   java.lang.String prefix,
                                                   java.lang.String suffix)
                                            throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### currentTimeSeconds

          public static long currentTimeSeconds(java.lang.System self)

      Get the current time in seconds
      Parameters:
        `self` - placeholder variable used by Groovy categories; ignored for default static methods
      Returns:
        the difference, measured in seconds, between the current time and midnight, January 1, 1970 UTC.
      See Also:
        `System.currentTimeMillis()`